%global gem_name coderay

%bcond_with shoulda

Summary: Fast syntax highlighting for selected languages
Name:    rubygem-%{gem_name}
Version: 1.1.3
Release: 6%{?dist}
License: MIT
URL: http://coderay.rubychan.de
Source0: https://rubygems.org/gems/%{gem_name}-%{version}.gem
# step1: git clone https://github.com/rubychan/coderay --no-checkout
# step2: cd coderay && git archive -v -o coderay-1.1.3-tests.txz v1.1.3 test spec
Source1: %{gem_name}-%{version}-tests.txz

Patch3000: rubygem-coderay-1.1.3-fix-tests-Array-on-ruby-3.0.patch

BuildRequires: ruby(release) rubygems-devel ruby rubygem(test-unit) rubygem(rspec)
%if %{with shoulda}
BuildRequires: rubygem(shoulda-context)
%endif
BuildArch: noarch

%description
Fast and easy syntax highlighting for selected languages, written in Ruby.  Comes with RedCloth
integration and LOC counter.

%prep
%setup -n %{gem_name}-%{version} -b 1

pushd ..
%patch3000 -p1
popd

%build
gem build ../%{gem_name}-%{version}.gemspec

%install
%gem_install
mkdir -p %{buildroot}%{gem_dir}
cp -a .%{gem_dir}/* %{buildroot}%{gem_dir}/

mkdir -p %{buildroot}%{_bindir}
cp -a .%{_bindir}/* %{buildroot}%{_bindir}/

find %{buildroot}%{gem_instdir}/bin -type f | xargs chmod a+x

%check
pushd .%{gem_instdir}
cp -r %{_builddir}/spec .
cp -r %{_builddir}/test .

for file in \
  spec/spec_helper.rb \
  test/executable/suite.rb \
  test/functional/for_redcloth.rb \
  test/functional/suite.rb \
  test/unit/suite.rb; do
  sed -i "/^require 'simplecov'/ s/^/#/" "${file}"
done

LANG=C.UTF-8
ruby ./test/functional/suite.rb
ruby ./test/functional/for_redcloth.rb
ruby ./test/unit/suite.rb
%if %{with shoulda}
ruby ./test/executable/suite.rb
%endif
rspec spec
popd

%files
%license %{gem_instdir}/MIT-LICENSE
%doc %{gem_docdir}
%doc %{gem_instdir}/README_INDEX.rdoc
%{_bindir}/coderay
%{gem_instdir}/bin
%{gem_libdir}
%exclude %{gem_cache}
%{gem_spec}

%changelog
* Thu Sep 26 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.1.3-6
- Rebuilt for clarifying the packages requirement in BaseOS and AppStream

* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.1.3-5
- Rebuilt for loongarch release

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.1.3-4
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.1.3-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.1.3-2
- Rebuilt for OpenCloudOS Stream 23

* Mon Mar 20 2023 Shuo Wang <abushwang@tencent.com> - 1.1.3-1
- initial build
